package  
{
	import flash.display.DisplayObject;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author Kragnir
	 */
	public class Sidebar extends Sprite
	{
		[Embed(source = "../images/emerald.png")]
		private var timeCrystal:Class;
		
		private var tDisplayer:textdisplayer;
		
		public var crystalDisplay:DisplayObject;
		
		public var hpLeft:int;
		public var timeLeft:int;
		public var crystalsLeft:int;
		
		public var hpLeftS:int;
		public var timeLeftS:int;
		public var crystalsLeftS:int;
		
		public var sideBarBackground:Shape;
		public var timeBar:Shape;
		
		public var hpBar:Shape;
		
		public var crystalCounter:DisplayObject;
		
		public function save():void
		{
			hpLeftS = hpLeft;
			timeLeftS = timeLeft;
			crystalsLeftS = crystalsLeft;
		}
		
		public function load():void
		{
			hpLeft = hpLeftS;
			timeLeft = timeLeftS;
			crystalsLeft = crystalsLeftS;
			removeChild(crystalCounter);
			crystalCounter = tDisplayer.getTextSprite(String(crystalsLeft));
			crystalCounter.x = 30;
			crystalCounter.y = 68;
			addChild(crystalCounter);
			timeBar.graphics.beginFill(0x00ff00);
			timeBar.graphics.drawRect(0, 0, 100, 20);
			timeBar.graphics.endFill();	
			var newRight:int = Math.floor((timeLeft + 1) / 3);
			timeBar.graphics.beginFill(0x444444);
			timeBar.graphics.drawRect(newRight, 0, 100-newRight, 20);
			timeBar.graphics.endFill();
			hpBar.graphics.beginFill(0xff0000);
			hpBar.graphics.drawRect(0, 0, 100, 20);
			hpBar.graphics.endFill();
			newRight = Math.floor(hpLeft * 10);
			hpBar.graphics.beginFill(0x444444);
			hpBar.graphics.drawRect(newRight, 0, 100-newRight, 20);
			hpBar.graphics.endFill();
		}
		
		public function playerDead():Boolean
		{
			if (hpLeft <= 0)
				return true;
			if (timeLeft <= 0 && crystalsLeft <= 0)
				return true;
			return false;
		}
		
		public function getHit():Boolean
		{
			var oldRight:int = Math.floor(hpLeft * 10);
			hpLeft--;
			var newRight:int = Math.floor(hpLeft * 10);
			if (oldRight != newRight)
			{
				hpBar.graphics.beginFill(0x444444);
				hpBar.graphics.drawRect(newRight, 0, 10, 20);
				hpBar.graphics.endFill();
			}
			if (hpLeft == 0)
			{
				return true;
			}
			return false;
		}
		
		public function tick():void
		{
			if (timeLeft == 0)
			{
				crystalsLeft--;
				timeLeft = 300;
				timeBar.graphics.beginFill(0x00ff00);
				timeBar.graphics.drawRect(0, 0, 100, 20);
				timeBar.graphics.endFill();	
				removeChild(crystalCounter);
				crystalCounter = tDisplayer.getTextSprite(String(crystalsLeft));
				crystalCounter.x = 30;
				crystalCounter.y = 68;
				addChild(crystalCounter);
			}
			else
			{
				var oldRight:int = Math.floor((timeLeft + 1) / 3);
				timeLeft--;
				var newRight:int = Math.floor((timeLeft + 1) / 3);
				if (oldRight != newRight)
				{
					timeBar.graphics.beginFill(0x444444);
					timeBar.graphics.drawRect(newRight, 0, 1, 20);
					timeBar.graphics.endFill();
				}
			}
		}
		
		public function Sidebar(tGenerator:textdisplayer) 
		{
			timeLeft = 300;
			crystalsLeft = 20;
			hpLeft = 10;
			timeLeftS = 300;
			crystalsLeftS = 20;
			hpLeftS = 10;
			tDisplayer = tGenerator;
			crystalCounter = tDisplayer.getTextSprite(String(crystalsLeft));
			crystalCounter.x = 30;
			crystalCounter.y = 68;
			sideBarBackground = new Shape();
			sideBarBackground.graphics.beginFill(0x444444);
			sideBarBackground.graphics.drawRect(0, 0, 160, 640);
			sideBarBackground.graphics.endFill();
			addChild(sideBarBackground);
			timeBar = new Shape();
			timeBar.graphics.beginFill(0x00ff00);
			timeBar.graphics.drawRect(0, 0, 100, 20);
			timeBar.graphics.endFill();
			timeBar.x = 30;
			timeBar.y = 30;
			hpBar = new Shape();
			hpBar.graphics.beginFill(0xff0000);
			hpBar.graphics.drawRect(0, 0, 100, 20);
			hpBar.graphics.endFill();
			hpBar.x = 30;
			hpBar.y = 100;
			crystalDisplay = new timeCrystal();
			crystalDisplay.scaleX = 2;
			crystalDisplay.scaleY = 2;
			crystalDisplay.x = 98;
			crystalDisplay.y = 60;
			addChild(crystalDisplay);
			addChild(hpBar);
			addChild(timeBar);
			addChild(crystalCounter);
			x = 640;
		}
	}
}