package  
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.geom.Matrix;
	/**
	 * ...
	 * @author Kragnir
	 */
	 
	public class textdisplayer
	{
		[Embed(source = "../images/lettersandnumbers.png")]
		private var allLettersAndNumbers:Class;
		
		private var myImage:DisplayObject;
		private var letters:Vector.<BitmapData> = new Vector.<BitmapData>();
		private var numbers:Vector.<BitmapData> = new Vector.<BitmapData>();
		
		public function getTextSprite(tString:String):Sprite
		{
			var tSprite:Sprite = new Sprite();
			for (var i:int = 0; i < tString.length; i++ )
			{
				var tImage:Bitmap;
				if (tString.charAt(i) != ' ')
				{
					if (tString.charAt(i) >= 'A' && tString.charAt(i) <= 'Z')
					{
						tImage = new Bitmap(letters[tString.charCodeAt(i) - 65]);
						tImage.x = i * 17;
						tImage.y = 0;
						tSprite.addChild(tImage);
					}
					if (tString.charAt(i) >= '0' && tString.charAt(i) <= '9')
					{
						tImage = new Bitmap(numbers[tString.charCodeAt(i) - 48]);
						tImage.x = i * 17;
						tImage.y = 0;
						tSprite.addChild(tImage);
					}
				}
			}
			return tSprite;
		}
		
		public function textdisplayer() 
		{
			myImage = new allLettersAndNumbers();
			var i:int;
			for (i = 0; i < 26; i++ )
			{
				letters[i] = new BitmapData(16,16, true, 0);
				letters[i].draw(myImage, new Matrix(1, 0, 0, 1, -i * 16, 0));
			}
			for (i = 0; i < 10; i++ )
			{
				numbers[i] = new BitmapData(16,16, true, 0);
				numbers[i].draw(myImage, new Matrix(1, 0, 0, 1, -i * 16, -32));
			}
		}
	}

}